Index: /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/MultiObjectiveGoalSeekingProblem.cs
===================================================================
--- /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/MultiObjectiveGoalSeekingProblem.cs	(revision 14332)
+++ /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/MultiObjectiveGoalSeekingProblem.cs	(revision 14333)
@@ -23,5 +23,4 @@
 using System.Collections.Generic;
 using System.Linq;
-using System.Windows.Forms;
 using HeuristicLab.Collections;
 using HeuristicLab.Common;
@@ -39,342 +38,83 @@
   [StorableClass]
   public sealed class MultiObjectiveGoalSeekingProblem : MultiObjectiveBasicProblem<RealVectorEncoding>, IGoalSeekingProblem {
+    #region parameter names
     private const string ModifiableDatasetParameterName = "Dataset";
-    private const string ProblemDataParameterName = "ProblemData";
-    private const string ControllableParametersParameterName = "ControllableParameters";
-    private const string ControllableParameterBoundsParameterName = "ControllableParameterBounds";
-    private const string TargetGoalsParameterName = "TargetGoals";
-    private const string TargetsParameterName = "Targets";
-    private const string ModelCollectionParameterName = "ModelCollection";
-    private const string RowParameterName = "Row";
-    // these parameters are used by the pareto folding analyzer
+    private const string InputsParameterName = "Inputs";
+    private const string GoalsParameterName = "Goals";
+    private const string ModelsParameterName = "Models";
     private const string QualitySumCutoffParameterName = "QualitySumCutoff";
+    #endregion
 
     #region parameters
+    public IValueParameter<CheckedItemList<InputParameter>> InputsParameter {
+      get { return (IValueParameter<CheckedItemList<InputParameter>>)Parameters[InputsParameterName]; }
+    }
+    public IValueParameter<CheckedItemList<GoalParameter>> GoalsParameter {
+      get { return (IValueParameter<CheckedItemList<GoalParameter>>)Parameters[GoalsParameterName]; }
+    }
+    public IFixedValueParameter<ItemCollection<IRegressionModel>> ModelsParameter {
+      get { return (IFixedValueParameter<ItemCollection<IRegressionModel>>)Parameters[ModelsParameterName]; }
+    }
     public IFixedValueParameter<DoubleValue> QualitySumCutoffParameter {
       get { return (IFixedValueParameter<DoubleValue>)Parameters[QualitySumCutoffParameterName]; }
     }
-    public IValueParameter<IRegressionProblemData> ProblemDataParameter {
-      get { return (IValueParameter<IRegressionProblemData>)Parameters[ProblemDataParameterName]; }
-    }
-    public IValueParameter<CheckedItemList<StringValue>> ControllableParametersParameter {
-      get { return (IValueParameter<CheckedItemList<StringValue>>)Parameters[ControllableParametersParameterName]; }
-    }
-    public IValueParameter<DoubleMatrix> ControllableParameterBoundsParameter {
-      get { return (IValueParameter<DoubleMatrix>)Parameters[ControllableParameterBoundsParameterName]; }
-    }
-    public IFixedValueParameter<ItemCollection<IRegressionModel>> ModelCollectionParameter {
-      get { return (IFixedValueParameter<ItemCollection<IRegressionModel>>)Parameters[ModelCollectionParameterName]; }
-    }
-    public IValueParameter<CheckedItemList<StringValue>> TargetsParameter {
-      get { return (IValueParameter<CheckedItemList<StringValue>>)Parameters[TargetsParameterName]; }
-    }
-    public IValueParameter<DoubleMatrix> TargetGoalsParameter {
-      get { return (IValueParameter<DoubleMatrix>)Parameters[TargetGoalsParameterName]; }
-    }
-    public IFixedValueParameter<IntValue> RowParameter {
-      get { return (IFixedValueParameter<IntValue>)Parameters[RowParameterName]; }
-    }
-    #endregion
-
-    #region parameter properties
-    private IItemCollection<IRegressionModel> ModelCollection {
-      get { return ModelCollectionParameter.Value; }
-    }
-    public DoubleMatrix TargetGoals {
-      get { return TargetGoalsParameter.Value; }
-      set { TargetGoalsParameter.Value = value; }
-    }
-    public double QualitySumCutoff {
-      get { return QualitySumCutoffParameter.Value.Value; }
-      set { QualitySumCutoffParameter.Value.Value = value; }
-    }
-    #endregion
-
-    #region IProcessParameterOptimizationProblem properties
-    [Storable]
-    private IRegressionProblemData problemData;
-    public IRegressionProblemData ProblemData {
-      get { return problemData; }
-      set {
-        if (value == null || value == problemData) return;
-        var variables = value.Dataset.DoubleVariables.ToList();
-        if (Models.Any()) {
-          var targets = Models.Select(x => x.TargetVariable);
-          var hashset = new HashSet<string>(variables);
-          foreach (var target in targets) {
-            if (!hashset.Contains(target)) {
-              throw new ArgumentException(string.Format("Incompatible problem data. Target \"{0}\" is missing.", target));
-            }
-          }
-        }
-        problemData = value;
-        dataset = new ModifiableDataset(variables, variables.Select(x => new List<double> { ProblemData.Dataset.GetDoubleValue(x, Row) }));
-        ProblemDataParameter.Value = ProblemData;
-        UpdateControllableParameters();
-        UpdateTargetList();
-      }
-    }
-
-    public int Row {
-      get { return RowParameter.Value.Value; }
-      set { RowParameter.Value.Value = value; }
-    }
-
+    #endregion
+
+    #region IGoalSeekingProblem implementation
     public IEnumerable<IRegressionModel> Models {
-      get { return ModelCollectionParameter.Value; }
-    }
-
-    #region targets
-    public ICheckedItemList<StringValue> TargetList {
-      get { return TargetsParameter.Value; }
-      set { TargetsParameter.Value = (CheckedItemList<StringValue>)value; }
-    }
-    // convenience method
-    private IEnumerable<string> ActiveTargets {
-      get { return TargetList.CheckedItems.Select(x => x.Value.Value); }
-    }
-    #endregion
-
-    #region parameters
-    public ICheckedItemList<StringValue> ControllableParameters {
-      get { return ControllableParametersParameter.Value; }
-      set { ControllableParametersParameter.Value = (CheckedItemList<StringValue>)value; }
-    }
-    // convenience method 
-    private IEnumerable<string> ActiveParameters {
-      get { return ControllableParameters.CheckedItems.Select(x => x.Value.Value); }
-    }
-    public DoubleMatrix ControllableParameterBounds {
-      get { return ControllableParameterBoundsParameter.Value; }
-      set { ControllableParameterBoundsParameter.Value = value; }
-    }
-    #endregion
-    #endregion
-
-    #region IProcessParameterOptimizationProblem methods
-    #region models
+      get { return ModelsParameter.Value; }
+    }
+
+    public IEnumerable<GoalParameter> Goals {
+      get { return GoalsParameter.Value; }
+    }
+
+    public IEnumerable<InputParameter> Inputs {
+      get { return InputsParameter.Value; }
+    }
+
+    public void AddModel(IRegressionModel model) {
+      var models = ModelsParameter.Value;
+      models.Add(model);
+      GoalSeekingUtil.RaiseEvent(this, ModelsChanged);
+    }
+
+    public void RemoveModel(IRegressionModel model) {
+      var models = ModelsParameter.Value;
+      models.Remove(model);
+      GoalSeekingUtil.RaiseEvent(this, ModelsChanged);
+    }
+
+    public void Configure(IRegressionProblemData problemData, int row) {
+      GoalSeekingUtil.Configure(Goals, Inputs, problemData, row);
+    }
+
     public IEnumerable<double> GetEstimatedGoalValues(IEnumerable<double> parameterValues, bool round = false) {
       var ds = (ModifiableDataset)dataset.Clone();
-      foreach (var parameter in ActiveParameters.Zip(parameterValues, (p, v) => new { Name = p, Value = v })) {
+      foreach (var parameter in ActiveInputs.Zip(parameterValues, (p, v) => new { Name = p.Name, Value = v })) {
         ds.SetVariableValue(parameter.Value, parameter.Name, 0);
       }
       var rows = new[] { 0 }; // actually just one row
-
       var estimatedValues =
-        round ? ActiveTargets.Select(t => RoundToNearestStepMultiple(GetModels(t).Average(m => m.GetEstimatedValues(ds, rows).Single()), GetTargetStepSize(t)))
-              : ActiveTargets.Select(t => GetModels(t).Average(m => m.GetEstimatedValues(ds, rows).Single()));
+        round ? ActiveGoals.Select(t => RoundToNearestStepMultiple(GetModels(t.Name).Average(m => m.GetEstimatedValues(ds, rows).Single()), t.Step))
+              : ActiveGoals.Select(t => GetModels(t.Name).Average(m => m.GetEstimatedValues(ds, rows).Single()));
       return estimatedValues;
     }
 
-    public void AddModel(IRegressionModel model) {
-      var target = model.TargetVariable;
-      CheckIfDatasetContainsTarget(target);
-      ModelCollection.Add(model);
-      OnModelsChanged(this, EventArgs.Empty);
-    }
-
-    // method which throws an exception that can be caught in the event handler if the check fails
-    private void CheckIfDatasetContainsTarget(string target) {
-      if (dataset.DoubleVariables.All(x => x != target))
-        throw new ArgumentException(string.Format("Model target \"{0}\" does not exist in the dataset.", target));
-    }
-
-    public void RemoveModel(IRegressionModel model) {
-      ModelCollection.Remove(model);
-      OnModelsChanged(this, EventArgs.Empty);
-    }
-
     public event EventHandler ModelsChanged;
-    private void OnModelsChanged(object sender, EventArgs args) {
-      var changed = ModelsChanged;
-      if (changed == null) return;
-      changed(sender, args);
-    }
-    #endregion
-
-    #region targets
-    public bool GetTargetActive(string target) {
-      var item = TargetList.SingleOrDefault(x => x.Value == target);
-      if (item == null)
-        throw new ArgumentException(string.Format("SetTargetActive: Invalid target name {0}", target));
-      return TargetList.ItemChecked(item);
-    }
-
-    public void SetTargetActive(string target, bool active) {
-      var item = TargetList.SingleOrDefault(x => x.Value == target);
-      if (item == null)
-        throw new ArgumentException(string.Format("SetTargetActive: Invalid target name {0}", target));
-      TargetList.SetItemCheckedState(item, active);
-      OnTargetsChanged(this, EventArgs.Empty);
-    }
-
-    public double GetTargetGoal(string target) {
-      if (!IsValidTarget(target))
-        throw new ArgumentException(string.Format("The target variable name \"{0}\" does not exist in the dataset.", target));
-      int i = TargetGoals.RowNames.TakeWhile(x => x != target).Count();
-      return TargetGoals[i, 0];
-    }
-
-    public void SetTargetGoal(string target, double goal) {
-      if (!IsValidTarget(target))
-        throw new ArgumentException(string.Format("The target variable name \"{0}\" does not exist in the dataset.", target));
-      int i = TargetGoals.RowNames.TakeWhile(x => x != target).Count();
-      TargetGoals[i, 0] = goal;
-      OnTargetsChanged(this, EventArgs.Empty);
-    }
-
-    public double GetTargetWeight(string target) {
-      if (!IsValidTarget(target))
-        throw new ArgumentException(string.Format("The target variable name \"{0}\" does not exist in the dataset.", target));
-      int i = TargetGoals.RowNames.TakeWhile(x => x != target).Count();
-      return TargetGoals[i, 1];
-    }
-
-    public void SetTargetWeight(string target, double weight) {
-      if (!IsValidTarget(target))
-        throw new ArgumentException(string.Format("The target variable name \"{0}\" does not exist in the dataset.", target));
-      int i = TargetGoals.RowNames.TakeWhile(x => x != target).Count();
-      TargetGoals[i, 1] = weight;
-      OnTargetsChanged(this, EventArgs.Empty);
-    }
-
-    public double GetTargetVariance(string target) {
-      if (!IsValidTarget(target))
-        throw new ArgumentException(string.Format("The target variable name \"{0}\" does not exist in the dataset.", target));
-      int i = TargetGoals.RowNames.TakeWhile(x => x != target).Count();
-      return TargetGoals[i, 2];
-    }
-
-    public void SetTargetVariance(string target, double variance) {
-      if (!IsValidTarget(target))
-        throw new ArgumentException(string.Format("The target variable name \"{0}\" does not exist in the dataset.", target));
-      int i = TargetGoals.RowNames.TakeWhile(x => x != target).Count();
-      TargetGoals[i, 2] = variance;
-      OnTargetsChanged(this, EventArgs.Empty);
-    }
-
-    public double GetTargetStepSize(string target) {
-      if (!IsValidTarget(target))
-        throw new ArgumentException(string.Format("The target variable name \"{0}\" does not exist in the dataset.", target));
-      int i = TargetGoals.RowNames.TakeWhile(x => x != target).Count();
-      return TargetGoals[i, 3];
-    }
-
-    public void SetTargetStepSize(string target, double stepSize) {
-      if (!IsValidTarget(target))
-        throw new ArgumentException(string.Format("The target variable name \"{0}\" does not exist in the dataset.", target));
-      int i = TargetGoals.RowNames.TakeWhile(x => x != target).Count();
-      TargetGoals[i, 3] = stepSize;
-      OnTargetsChanged(this, EventArgs.Empty);
-    }
-
     public event EventHandler TargetsChanged;
-    private void OnTargetsChanged(object sender, EventArgs args) {
-      var changed = TargetsChanged;
-      if (changed == null) return;
-      changed(sender, args);
-    }
-    #endregion // targets
-
-    #region process parameters
-    /// <summary>
-    /// Returns the parameter bounds (min and max) and the step size for the specified parameter
-    /// </summary>
-    /// <param name="parameterName"></param>
-    /// <returns>A double array containing the values (min, max, step) in this order</returns>
-    public double[] GetParameterBounds(string parameterName) {
-      var index = ControllableParameters.TakeWhile(x => x.Value != parameterName).Count();
-      if (index < ControllableParameters.Count) {
-        var min = ControllableParameterBounds[index, 0];
-        var max = ControllableParameterBounds[index, 1];
-        var step = ControllableParameterBounds[index, 2];
-        return new[] { min, max, step };
-      }
-      throw new ArgumentException(string.Format("GetParameterBounds: Unknown parameter {0}.", parameterName));
-    }
-
-    public void SetParameterBounds(string parameterName, double min, double max, double step) {
-      int i = ControllableParameterBounds.RowNames.TakeWhile(x => x != parameterName).Count();
-      if (i < ControllableParameterBounds.Rows) {
-        ControllableParameterBounds[i, 0] = min;
-        ControllableParameterBounds[i, 1] = max;
-        ControllableParameterBounds[i, 2] = step;
-        UpdateEncoding();
-        OnParametersChanged(this, EventArgs.Empty);
-      } else {
-        throw new ArgumentException(string.Format("SetParameterBounds: Invalid parameter name {0}", parameterName));
-      }
-
-    }
-
-    public double GetParameterStepSize(string parameter) {
-      int i = ControllableParameterBounds.RowNames.TakeWhile(x => x != parameter).Count();
-      if (i < ControllableParameterBounds.Rows)
-        return ControllableParameterBounds[i, 2];
-      throw new ArgumentException(string.Format("GetParameterStepSize: Invalid parameter name {0}", parameter));
-    }
-
-    public void SetParameterStepSize(string parameter, double stepSize) {
-      int i = ControllableParameterBounds.RowNames.TakeWhile(x => x != parameter).Count();
-      if (i < ControllableParameterBounds.Rows) {
-        ControllableParameterBounds[i, 2] = stepSize;
-        OnParametersChanged(this, EventArgs.Empty);
-        return;
-      }
-      throw new ArgumentException(string.Format("SetParameterStepSize: Invalid parameter name {0}", parameter));
-    }
-
-    public bool GetParameterActive(string parameter) {
-      var item = ControllableParameters.SingleOrDefault(x => x.Value == parameter);
-      if (item == null)
-        throw new ArgumentException(string.Format("GetParameterActive: Invalid target name {0}", parameter));
-      return ControllableParameters.ItemChecked(item);
-    }
-
-    public void SetParameterActive(string parameter, bool active) {
-      var item = ControllableParameters.SingleOrDefault(x => x.Value == parameter);
-      if (item == null)
-        throw new ArgumentException(string.Format("SetParameterActive: Invalid target name {0}", parameter));
-      ControllableParameters.SetItemCheckedState(item, active);
-      OnParametersChanged(this, EventArgs.Empty);
-    }
-
-    public void SetControllableParameters(IEnumerable<string> parameterNames) {
-      ControllableParameters = new CheckedItemList<StringValue>();
-      foreach (var v in parameterNames) {
-        ControllableParameters.Add(new StringValue(v), false);
-      }
-      ControllableParameters.CheckedItemsChanged += ControllableParameters_OnItemsChanged;
-      ControllableParameterBounds = new DoubleMatrix(ControllableParameters.Count, 3);
-      ControllableParameterBounds.RowNames = GetControllableParameters();
-      ControllableParameterBounds.ColumnNames = new[] { "Min", "Max", "Step" };
-
-      for (int i = 0; i < ControllableParameters.Count; ++i) {
-        var itemName = ControllableParameters[i].Value;
-        var values = ProblemData.Dataset.GetReadOnlyDoubleValues(itemName).Where(x => !double.IsNaN(x) && !double.IsInfinity(x)).ToList();
-        if (!values.Any()) continue;
-
-        // add a 20% margin to allow the optimization algorithm more freedom of exploration
-        ControllableParameterBounds[i, 0] = 0.8 * values.Min(); // min
-        ControllableParameterBounds[i, 1] = 1.2 * values.Max(); // max
-        ControllableParameterBounds[i, 2] = 1e-6;               // step
-      }
-      OnParametersChanged(this, EventArgs.Empty);
-    }
-
-    public IEnumerable<string> GetControllableParameters() {
-      return ControllableParameters.Select(x => x.Value);
-    }
-
     public event EventHandler ParametersChanged;
-    private void OnParametersChanged(object sender, EventArgs args) {
-      var changed = ParametersChanged;
-      if (changed == null) return;
-      changed(sender, args);
-    }
-    #endregion // process parameters
-    #endregion // IGoalSeekingProblem methods
-
-    #region data members
+    #endregion
+
+    private IEnumerable<GoalParameter> ActiveGoals {
+      get { return Goals.Where(x => x.Active); }
+    }
+    private IEnumerable<InputParameter> ActiveInputs {
+      get { return Inputs.Where(x => x.Active); }
+    }
+    private double QualitySumCutoff {
+      get { return QualitySumCutoffParameter.Value.Value; }
+    }
+
     [Storable]
     private ModifiableDataset dataset; // modifiable dataset
@@ -389,5 +129,4 @@
       get { return (ValueParameter<BoolArray>)Parameters["Maximization"]; }
     }
-    #endregion
 
     #region constructors
@@ -397,5 +136,4 @@
     private MultiObjectiveGoalSeekingProblem(MultiObjectiveGoalSeekingProblem original, Cloner cloner) : base(original, cloner) {
       this.dataset = cloner.Clone(original.dataset);
-      this.problemData = cloner.Clone(original.problemData);
 
       RegisterEvents();
@@ -408,56 +146,22 @@
     [StorableHook(HookType.AfterDeserialization)]
     private void AfterDeserialization() {
-      if (Parameters.ContainsKey("Accuracy"))
-        Parameters.Remove("Accuracy");
-
-      if (!Parameters.ContainsKey(QualitySumCutoffParameterName)) {
-        Parameters.Add(new FixedValueParameter<DoubleValue>(QualitySumCutoffParameterName, new DoubleValue(0.2)));
-        QualitySumCutoffParameter.Hidden = true;
-      }
-
-      if (ProblemData == null && Parameters.ContainsKey(ProblemDataParameterName)) {
-        ProblemData = ProblemDataParameter.Value;
-      }
-
-      if (!Parameters.ContainsKey(ModifiableDatasetParameterName)) {
-        Parameters.Add(new ValueParameter<IDataset>(ModifiableDatasetParameterName, dataset) { Hidden = true });
-      }
-
-      // backwards-compatibility
-      if (Parameters.ContainsKey("Models")) {
-        var solutions = ((IFixedValueParameter<ItemCollection<IRegressionSolution>>)Parameters["Models"]).Value;
-        var models = new ItemCollection<IRegressionModel>();
-        foreach (var solution in solutions) {
-          var model = solution.Model;
-          model.TargetVariable = solution.ProblemData.TargetVariable;
-          models.Add(model);
-        }
-        if (Parameters.ContainsKey(ModelCollectionParameterName))
-          Parameters.Remove(ModelCollectionParameterName);
-        Parameters.Add(new FixedValueParameter<ItemCollection<IRegressionModel>>(ModelCollectionParameterName, models));
-      }
-
       RegisterEvents();
     }
 
     public MultiObjectiveGoalSeekingProblem() {
-      Parameters.Add(new ValueParameter<IRegressionProblemData>(ProblemDataParameterName, new RegressionProblemData()));
+      dataset = new ModifiableDataset();
       Parameters.Add(new ValueParameter<IDataset>(ModifiableDatasetParameterName, dataset) { Hidden = true });
-      Parameters.Add(new ValueParameter<CheckedItemList<StringValue>>(ControllableParametersParameterName));
-      Parameters.Add(new ValueParameter<CheckedItemList<StringValue>>(TargetsParameterName));
-      Parameters.Add(new ValueParameter<DoubleMatrix>(ControllableParameterBoundsParameterName));
-      Parameters.Add(new FixedValueParameter<ItemCollection<IRegressionModel>>(ModelCollectionParameterName, new ItemCollection<IRegressionModel>()));
-      Parameters.Add(new ValueParameter<DoubleMatrix>(TargetGoalsParameterName)); // model target weights
-      Parameters.Add(new FixedValueParameter<IntValue>(RowParameterName));
+      Parameters.Add(new ValueParameter<CheckedItemList<InputParameter>>(InputsParameterName));
+      Parameters.Add(new ValueParameter<CheckedItemList<GoalParameter>>(GoalsParameterName));
+      Parameters.Add(new FixedValueParameter<ItemCollection<IRegressionModel>>(ModelsParameterName, new ItemCollection<IRegressionModel>()));
       Parameters.Add(new FixedValueParameter<DoubleValue>(QualitySumCutoffParameterName, new DoubleValue(0.2)));
-
       QualitySumCutoffParameter.Hidden = true;
-
-      // when the problem is created, the problem data parameter will be set to a default value
-      // set the internal property to the same value
-      ProblemData = ProblemDataParameter.Value;
-
-      UpdateControllableParameters();
-      UpdateTargetList();
+      EncodingParameter.Hidden = true;
+      EvaluatorParameter.Hidden = true;
+      SolutionCreatorParameter.Hidden = true;
+      MaximizationParameter.Hidden = true;
+      GoalSeekingUtil.UpdateInputs(InputsParameter.Value, Models, InputParameterChanged);
+      Encoding = GoalSeekingUtil.CreateEncoding(ActiveInputs);
+      GoalSeekingUtil.UpdateTargets(GoalsParameter.Value, Models, GoalParameterChanged);
       RegisterEvents();
     }
@@ -466,24 +170,18 @@
     public override double[] Evaluate(Individual individual, IRandom random) {
       var vector = individual.RealVector();
-      vector.ElementNames = ActiveParameters;
-
+      vector.ElementNames = ActiveInputs.Select(x => x.Name);
       int i = 0;
       // round vector according to parameter step sizes
-      foreach (var parameter in ControllableParameters.CheckedItems) {
-        var step = ControllableParameterBounds[parameter.Index, 2];
-        vector[i] = RoundToNearestStepMultiple(vector[i], step);
+      foreach (var parameter in ActiveInputs) {
+        vector[i] = RoundToNearestStepMultiple(vector[i], parameter.Step);
         ++i;
       }
       var estimatedValues = GetEstimatedGoalValues(vector, round: true);
-      var qualities = TargetList.CheckedItems.Zip(estimatedValues, (t, v) => new { Name = t.Value.Value, Index = t.Index, EstimatedValue = v })
-                                .Select(target => {
-                                  var goal = TargetGoals[target.Index, 0];
-                                  var weight = TargetGoals[target.Index, 1];
-                                  var variance = TargetGoals[target.Index, 2];
-                                  return weight * Math.Pow(target.EstimatedValue - goal, 2) / variance;
-                                });
+      var qualities = ActiveGoals.Zip(estimatedValues, (t, v) => new { Target = t, EstimatedValue = v })
+                                 .Select(x => x.Target.Weight * Math.Pow(x.EstimatedValue - x.Target.Goal, 2) / x.Target.Variance);
       return qualities.ToArray();
     }
 
+    #region pareto analyzer
     public override void Analyze(Individual[] individuals, double[][] qualities, ResultCollection results, IRandom random) {
       var matrix = FilterFrontsByQualitySum(individuals, qualities, Math.Max(QualitySumCutoff, qualities.Min(x => x.Sum())));
@@ -498,18 +196,18 @@
 
     private DoubleMatrix FilterFrontsByQualitySum(Individual[] individuals, double[][] qualities, double qualitySumCutoff) {
-      var activeParameters = ActiveParameters.ToList();
-      var activeTargets = ActiveTargets.ToList();
+      var activeParameters = ActiveInputs.ToList();
+      var activeGoals = ActiveGoals.ToList();
       var filteredModels = new List<double[]>();
       var rowNames = new List<string>();
       // build list of column names by combining target and parameter names (with their respective original and estimated values)
       var columnNames = new List<string> { "Quality Sum" };
-      foreach (var target in activeTargets) {
-        columnNames.Add(target);
-        columnNames.Add(target + " (estimated)");
-      }
-      foreach (var controllableParameter in activeParameters) {
-        columnNames.Add(controllableParameter);
-        columnNames.Add(controllableParameter + " (estimated)");
-        columnNames.Add(controllableParameter + " (deviation)");
+      foreach (var target in activeGoals) {
+        columnNames.Add(target.Name);
+        columnNames.Add(target.Name + " (estimated)");
+      }
+      foreach (var parameter in activeParameters) {
+        columnNames.Add(parameter.Name);
+        columnNames.Add(parameter.Name + " (estimated)");
+        columnNames.Add(parameter.Name + " (deviation)");
       }
       // filter models based on their quality sum; remove duplicate models
@@ -524,14 +222,14 @@
         rowValues[0] = qualitySum;
         int offset = 1;
-        for (int j = 0; j < activeTargets.Count * 2; j += 2) {
+        for (int j = 0; j < activeGoals.Count * 2; j += 2) {
           int k = j + offset;
-          var goal = GetTargetGoal(activeTargets[j / 2]);
+          var goal = activeGoals[j / 2].Goal;
           rowValues[k] = goal; // original value 
           rowValues[k + 1] = estimatedValues[j / 2]; // estimated value
         }
-        offset += activeTargets.Count * 2;
+        offset += activeGoals.Count * 2;
         for (int j = 0; j < activeParameters.Count * 3; j += 3) {
           int k = j + offset;
-          rowValues[k] = problemData.Dataset.GetDoubleValue(columnNames[k], Row);
+          rowValues[k] = 0; // TODO: figure this out and fix
           rowValues[k + 1] = vector[j / 3];
           rowValues[k + 2] = rowValues[k + 1] - rowValues[k];
